<?php

/**
 * EZHIFU 易支付(www.ezhifu.org) 易支付免签约支付插件
 * 无需签约，快速接入
 */

if (!defined('IN_ECTOUCH'))
{
    die('Hacking attempt');
}

$payment_lang = ROOT_PATH . 'lang/' .$GLOBALS['_CFG']['lang']. '/payment/ezhifu.php';

if (file_exists($payment_lang))
{
    global $_LANG;

    include_once($payment_lang);
}

/* 模块的基本信息 */
if (isset($set_modules) && $set_modules == TRUE)
{
    $i = isset($modules) ? count($modules) : 0;

    /* 代码 */
    $modules[$i]['code']    = basename(__FILE__, '.php');

    /* 描述对应的语言项 */
    $modules[$i]['desc']    = 'ezhifu_desc';

    /* 是否支持货到付款 */
    $modules[$i]['is_cod']  = '0';

    /* 是否支持在线支付 */
    $modules[$i]['is_online']  = '1';

    /* 作者 */
    $modules[$i]['author']  = 'EZHIFU';

    /* 网址 */
    $modules[$i]['website'] = 'http://www.ezhifu.org';

    /* 版本号 */
    $modules[$i]['version'] = '1.0.0';

    /* 配置信息 */
    $modules[$i]['config']  = array(
        array('name' => 'ezhifu_APPID',      'type' => 'text',   'value' => ''),
        array('name' => 'ezhifu_APPKEY',     'type' => 'text',   'value' => ''),
        array('name' => 'ezhifu_pay_method', 'type' => 'select', 'value' => '')
    );

    return;
}

/**
 * 类
 */
class ezhifu
{
    function __construct()
    {
        $this->ezhifu();
    }

    /**
     * 构造函数
     *
     * @access  public
     * @param
     *
     * @return void
     */
    function ezhifu()
    {

    }

    /**
     * 生成支付代码
     * @param   array   $order      订单信息
     * @param   array   $payment    支付方式信息
     */
    function get_code($order, $payment)
    {
        if (!defined('EC_CHARSET'))
        {
            $charset = 'utf-8';
        }
        else
        {
            $charset = EC_CHARSET;
        }
        //整理参数
        $url = "?appid={$payment['ezhifu_APPID']}&money={$order['order_amount']}&subject={$order['order_sn']}&logid={$order['log_id']}&returnurl=".urlencode(return_url(basename(__FILE__, '.php')))."&callback=".urlencode(return_url(basename(__FILE__, '.php')));
        $real_method = $payment['ezhifu_pay_method'];
        $html = "";
        switch ($real_method){
            case '0'://双通道
                $html = '<a href="http://pay.ezhifu.org/'.$url.'&type=1" target="_blank"><img src="http://pay.ezhifu.org/static/wechat.png" style="height:40px;margin-right:25px"></a><a href="http://pay.ezhifu.org/'.$url.'&type=2" target="_blank"><img src="http://pay.ezhifu.org/static/alipay.png" height="40px"></a>';
                break;
            case '1'://仅微信
                $html = '<a href="http://pay.ezhifu.org/'.$url.'&type=1" target="_blank"><img src="http://pay.ezhifu.org/static/wechat.png" style="height:40px;"></a>';
                break;
            case '2'://仅支付宝
                $html = '<a href="http://pay.ezhifu.org/'.$url.'&type=2" target="_blank"><img src="http://pay.ezhifu.org/static/alipay.png" height="40px"></a>';
                break;
        }

        return '<div style="text-align:center;padding:10px">'.$html.'</div>';
    }

    /**
     * 响应操作
     */
    function respond()
    {
        $payment  = get_payment($_GET['code']);
        unset($_GET['code']);
        $sign = $_GET['sign'];
        unset($_GET['sign']);
        ksort($_GET);
        if(md5(http_build_query($_GET).$payment['ezhifu_APPKEY'])!=$sign){
            return false;
        }
        //校验成功
        $order_sn = $_GET['logid'];
        /* 检查支付的金额是否相符 */
        if (!check_money($order_sn, $_GET['money']))
        {
            return false;
        }
        order_paid($order_sn);
        return true;
    }
}
?>